# RectangleGraphics

#### new Cesium.RectangleGraphics(options)
engine/Source/DataSources/RectangleGraphics.js 46

Describes graphics for a `Rectangle`. The rectangle conforms to the curvature of the globe and can be placed on the surface or at altitude and can optionally be extruded into a volume.

Name | Type | Description
--- | --- | ---
`options` | RectangleGraphics.ConstructorOptions | optional Object describing initialization options

##### Demo:

- Cesium Sandcastle Rectangle Demo

##### See:

- Entity

### Members

#### classificationType : Property|undefined
engine/Source/DataSources/RectangleGraphics.js 240

Gets or sets the `ClassificationType` Property specifying whether this rectangle will classify terrain, 3D Tiles, or both when on the ground.

Default Value: `ClassificationType.BOTH`

#### coordinates : Property|undefined
engine/Source/DataSources/RectangleGraphics.js 115

Gets or sets the Property specifying the `Rectangle`.

#### readonly definitionChanged : Event
engine/Source/DataSources/RectangleGraphics.js 96

Gets the event that is raised whenever a property or sub-property is changed or modified.

#### distanceDisplayCondition : Property|undefined
engine/Source/DataSources/RectangleGraphics.js 230

Gets or sets the `DistanceDisplayCondition` Property specifying at what distance from the camera that this rectangle will be displayed.

#### extrudedHeight : Property|undefined
engine/Source/DataSources/RectangleGraphics.js 139

Gets or sets the numeric Property specifying the altitude of the rectangle extrusion. Setting this property creates volume starting at height and ending at this altitude.

#### extrudedHeightReference : Property|undefined
engine/Source/DataSources/RectangleGraphics.js 147

Gets or sets the Property specifying the extruded `HeightReference`.

Default Value: `HeightReference.NONE`

#### fill : Property|undefined
engine/Source/DataSources/RectangleGraphics.js 179

Gets or sets the boolean Property specifying whether the rectangle is filled with the provided material.

Default Value: `true`

#### granularity : Property|undefined
engine/Source/DataSources/RectangleGraphics.js 171

Gets or sets the numeric Property specifying the angular distance between points on the rectangle.

Default Value: `{CesiumMath.RADIANS_PER_DEGREE}`

#### height : Property|undefined
engine/Source/DataSources/RectangleGraphics.js 123

Gets or sets the numeric Property specifying the altitude of the rectangle.

Default Value: `0.0`

#### heightReference : Property|undefined
engine/Source/DataSources/RectangleGraphics.js 131

Gets or sets the Property specifying the `HeightReference`.

Default Value: `HeightReference.NONE`

#### material : MaterialProperty
engine/Source/DataSources/RectangleGraphics.js 187

Gets or sets the Property specifying the material used to fill the rectangle.

Default Value: `Color.WHITE`

#### outline : Property|undefined
engine/Source/DataSources/RectangleGraphics.js 195

Gets or sets the Property specifying whether the rectangle is outlined.

Default Value: `false`

#### outlineColor : Property|undefined
engine/Source/DataSources/RectangleGraphics.js 203

Gets or sets the Property specifying the `Color` of the outline.

Default Value: `Color.BLACK`

#### outlineWidth : Property|undefined
engine/Source/DataSources/RectangleGraphics.js 214

Gets or sets the numeric Property specifying the width of the outline.

Note: This property will be ignored on all major browsers on Windows platforms. For details, see (@link https://github.com/CesiumGS/cesium/issues/40}.

Default Value: `1.0`

#### rotation : Property|undefined
engine/Source/DataSources/RectangleGraphics.js 155

Gets or sets the numeric property specifying the rotation of the rectangle clockwise from north.

Default Value: `0`

#### shadows : Property|undefined
engine/Source/DataSources/RectangleGraphics.js 223

Get or sets the enum Property specifying whether the rectangle casts or receives shadows from light sources.

Default Value: `ShadowMode.DISABLED`

#### show : Property|undefined
engine/Source/DataSources/RectangleGraphics.js 108

Gets or sets the boolean Property specifying the visibility of the rectangle.

Default Value: `true`

#### stRotation : Property|undefined
engine/Source/DataSources/RectangleGraphics.js 163

Gets or sets the numeric property specifying the rotation of the rectangle texture counter-clockwise from north.

Default Value: `0`

#### zIndex : ConstantProperty|undefined
engine/Source/DataSources/RectangleGraphics.js 248

Gets or sets the zIndex Property specifying the ordering of the rectangle. Only has an effect if the rectangle is constant and neither height or extrudedHeight are specified.

Default Value: `0`

### Methods

#### clone(result) → RectangleGraphics
engine/Source/DataSources/RectangleGraphics.js 257

Duplicates this instance.

Name | Type | Description
--- | --- | ---
`result` | RectangleGraphics | optional The object onto which to store the result.

##### Returns:

The modified result parameter or a new instance if one was not provided.

#### merge(source)
engine/Source/DataSources/RectangleGraphics.js 288

Assigns each unassigned property on this object to the value of the same property on the provided source object.

Name | Type | Description
--- | --- | ---
`source` | RectangleGraphics | The object to be merged into this object.

### Type Definitions

#### Cesium.RectangleGraphics.ConstructorOptions
engine/Source/DataSources/RectangleGraphics.js 8

Initialization options for the RectangleGraphics constructor

##### Properties:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`show` | Property | boolean | <optional> | true | A boolean Property specifying the visibility of the rectangle.
`coordinates` | Property | Rectangle | <optional> |  | The Property specifying the `Rectangle`.
`height` | Property | number | <optional> | 0 | A numeric Property specifying the altitude of the rectangle relative to the ellipsoid surface.
`heightReference` | Property | HeightReference | <optional> | HeightReference.NONE | A Property specifying what the height is relative to.
`extrudedHeight` | Property | number | <optional> |  | A numeric Property specifying the altitude of the rectangle's extruded face relative to the ellipsoid surface.
`extrudedHeightReference` | Property | HeightReference | <optional> | HeightReference.NONE | A Property specifying what the extrudedHeight is relative to.
`rotation` | Property | number | <optional> | 0.0 | A numeric property specifying the rotation of the rectangle clockwise from north.
`stRotation` | Property | number | <optional> | 0.0 | A numeric property specifying the rotation of the rectangle texture counter-clockwise from north.
`granularity` | Property | number | <optional> | Cesium.Math.RADIANS_PER_DEGREE | A numeric Property specifying the angular distance between points on the rectangle.
`fill` | Property | boolean | <optional> | true | A boolean Property specifying whether the rectangle is filled with the provided material.
`material` | MaterialProperty | Color | <optional> | Color.WHITE | A Property specifying the material used to fill the rectangle.
`outline` | Property | boolean | <optional> | false | A boolean Property specifying whether the rectangle is outlined.
`outlineColor` | Property | Color | <optional> | Color.BLACK | A Property specifying the `Color` of the outline.
`outlineWidth` | Property | number | <optional> | 1.0 | A numeric Property specifying the width of the outline.
`shadows` | Property | ShadowMode | <optional> | ShadowMode.DISABLED | An enum Property specifying whether the rectangle casts or receives shadows from light sources.
`distanceDisplayCondition` | Property | DistanceDisplayCondition | <optional> |  | A Property specifying at what distance from the camera that this rectangle will be displayed.
`classificationType` | Property | ClassificationType | <optional> | ClassificationType.BOTH | An enum Property specifying whether this rectangle will classify terrain, 3D Tiles, or both when on the ground.
`zIndex` | Property | number | <optional> | 0 | A Property specifying the zIndex used for ordering ground geometry. Only has an effect if the rectangle is constant and neither height or extrudedHeight are specified.

Need help? The fastest way to get answers is from the community and team on the Cesium Forum.